!
! Copyright (C) by Argonne National Laboratory
!     See COPYRIGHT in top-level directory
!

! -- THIS FILE IS AUTO-GENERATED -- 

MODULE mpi_sizeofs
    IMPLICIT NONE
    PUBLIC :: MPI_SIZEOF
    INTERFACE MPI_SIZEOF
        MODULE PROCEDURE MPI_SIZEOF_CH1
        MODULE PROCEDURE MPI_SIZEOF_CH1V
        MODULE PROCEDURE MPI_SIZEOF_L4
        MODULE PROCEDURE MPI_SIZEOF_L4V
        MODULE PROCEDURE MPI_SIZEOF_I1
        MODULE PROCEDURE MPI_SIZEOF_I1V
        MODULE PROCEDURE MPI_SIZEOF_I2
        MODULE PROCEDURE MPI_SIZEOF_I2V
        MODULE PROCEDURE MPI_SIZEOF_I4
        MODULE PROCEDURE MPI_SIZEOF_I4V
        MODULE PROCEDURE MPI_SIZEOF_I8
        MODULE PROCEDURE MPI_SIZEOF_I8V
        MODULE PROCEDURE MPI_SIZEOF_R4
        MODULE PROCEDURE MPI_SIZEOF_R4V
        MODULE PROCEDURE MPI_SIZEOF_R8
        MODULE PROCEDURE MPI_SIZEOF_R8V
        MODULE PROCEDURE MPI_SIZEOF_CX8
        MODULE PROCEDURE MPI_SIZEOF_CX8V
        MODULE PROCEDURE MPI_SIZEOF_CX16
        MODULE PROCEDURE MPI_SIZEOF_CX16V
    END INTERFACE
    
    CONTAINS
    
    SUBROUTINE MPI_SIZEOF_CH1(X, SIZE, IERRROR)
        CHARACTER :: X
        INTEGER :: SIZE, IERRROR
        SIZE = 1
        IERRROR = 0
    END SUBROUTINE MPI_SIZEOF_CH1
    
    SUBROUTINE MPI_SIZEOF_CH1V(X, SIZE, IERRROR)
        CHARACTER :: X(*)
        INTEGER :: SIZE, IERRROR
        SIZE = 1
        IERRROR = 0
    END SUBROUTINE MPI_SIZEOF_CH1V
    
    SUBROUTINE MPI_SIZEOF_L4(X, SIZE, IERRROR)
        LOGICAL :: X
        INTEGER :: SIZE, IERRROR
        SIZE = 4
        IERRROR = 0
    END SUBROUTINE MPI_SIZEOF_L4
    
    SUBROUTINE MPI_SIZEOF_L4V(X, SIZE, IERRROR)
        LOGICAL :: X(*)
        INTEGER :: SIZE, IERRROR
        SIZE = 4
        IERRROR = 0
    END SUBROUTINE MPI_SIZEOF_L4V
    
    SUBROUTINE MPI_SIZEOF_I1(X, SIZE, IERRROR)
        INTEGER*1 :: X
        INTEGER :: SIZE, IERRROR
        SIZE = 1
        IERRROR = 0
    END SUBROUTINE MPI_SIZEOF_I1
    
    SUBROUTINE MPI_SIZEOF_I1V(X, SIZE, IERRROR)
        INTEGER*1 :: X(*)
        INTEGER :: SIZE, IERRROR
        SIZE = 1
        IERRROR = 0
    END SUBROUTINE MPI_SIZEOF_I1V
    
    SUBROUTINE MPI_SIZEOF_I2(X, SIZE, IERRROR)
        INTEGER*2 :: X
        INTEGER :: SIZE, IERRROR
        SIZE = 2
        IERRROR = 0
    END SUBROUTINE MPI_SIZEOF_I2
    
    SUBROUTINE MPI_SIZEOF_I2V(X, SIZE, IERRROR)
        INTEGER*2 :: X(*)
        INTEGER :: SIZE, IERRROR
        SIZE = 2
        IERRROR = 0
    END SUBROUTINE MPI_SIZEOF_I2V
    
    SUBROUTINE MPI_SIZEOF_I4(X, SIZE, IERRROR)
        INTEGER*4 :: X
        INTEGER :: SIZE, IERRROR
        SIZE = 4
        IERRROR = 0
    END SUBROUTINE MPI_SIZEOF_I4
    
    SUBROUTINE MPI_SIZEOF_I4V(X, SIZE, IERRROR)
        INTEGER*4 :: X(*)
        INTEGER :: SIZE, IERRROR
        SIZE = 4
        IERRROR = 0
    END SUBROUTINE MPI_SIZEOF_I4V
    
    SUBROUTINE MPI_SIZEOF_I8(X, SIZE, IERRROR)
        INTEGER*8 :: X
        INTEGER :: SIZE, IERRROR
        SIZE = 8
        IERRROR = 0
    END SUBROUTINE MPI_SIZEOF_I8
    
    SUBROUTINE MPI_SIZEOF_I8V(X, SIZE, IERRROR)
        INTEGER*8 :: X(*)
        INTEGER :: SIZE, IERRROR
        SIZE = 8
        IERRROR = 0
    END SUBROUTINE MPI_SIZEOF_I8V
    
    SUBROUTINE MPI_SIZEOF_R4(X, SIZE, IERRROR)
        REAL*4 :: X
        INTEGER :: SIZE, IERRROR
        SIZE = 4
        IERRROR = 0
    END SUBROUTINE MPI_SIZEOF_R4
    
    SUBROUTINE MPI_SIZEOF_R4V(X, SIZE, IERRROR)
        REAL*4 :: X(*)
        INTEGER :: SIZE, IERRROR
        SIZE = 4
        IERRROR = 0
    END SUBROUTINE MPI_SIZEOF_R4V
    
    SUBROUTINE MPI_SIZEOF_R8(X, SIZE, IERRROR)
        REAL*8 :: X
        INTEGER :: SIZE, IERRROR
        SIZE = 8
        IERRROR = 0
    END SUBROUTINE MPI_SIZEOF_R8
    
    SUBROUTINE MPI_SIZEOF_R8V(X, SIZE, IERRROR)
        REAL*8 :: X(*)
        INTEGER :: SIZE, IERRROR
        SIZE = 8
        IERRROR = 0
    END SUBROUTINE MPI_SIZEOF_R8V
    
    SUBROUTINE MPI_SIZEOF_CX8(X, SIZE, IERRROR)
        COMPLEX*8 :: X
        INTEGER :: SIZE, IERRROR
        SIZE = 8
        IERRROR = 0
    END SUBROUTINE MPI_SIZEOF_CX8
    
    SUBROUTINE MPI_SIZEOF_CX8V(X, SIZE, IERRROR)
        COMPLEX*8 :: X(*)
        INTEGER :: SIZE, IERRROR
        SIZE = 8
        IERRROR = 0
    END SUBROUTINE MPI_SIZEOF_CX8V
    
    SUBROUTINE MPI_SIZEOF_CX16(X, SIZE, IERRROR)
        COMPLEX*16 :: X
        INTEGER :: SIZE, IERRROR
        SIZE = 16
        IERRROR = 0
    END SUBROUTINE MPI_SIZEOF_CX16
    
    SUBROUTINE MPI_SIZEOF_CX16V(X, SIZE, IERRROR)
        COMPLEX*16 :: X(*)
        INTEGER :: SIZE, IERRROR
        SIZE = 16
        IERRROR = 0
    END SUBROUTINE MPI_SIZEOF_CX16V
END MODULE mpi_sizeofs
